gp-grid-logo

Basic Usage

Build your first gp-grid table in Vue 3, configuring columns, binding reactive data sources, and exploring the component's reactive prop interface together.

This guide covers the fundamentals of using gp-grid in your Vue 3 application.

Don't forget to import the stylesheet once at the root of your app (e.g. main.ts):

import "@gp-grid/vue/dist/styles.css";

Minimal Example

<script setup lang="ts">
import { Grid, type ColumnDefinition } from "@gp-grid/vue";

const columns: ColumnDefinition[] = [
  { field: "id", cellDataType: "number", width: 80, headerName: "ID" },
  { field: "name", cellDataType: "text", width: 200, headerName: "Name" },
];

const data = [
  { id: 1, name: "Giovanni Rossi" },
  { id: 2, name: "Luca Verdi" },
];
</script>
<template>
  <div style="width: 100%; height: 400px">
    <Grid :columns="columns" :row-data="data" :row-height="36" />
  </div>
</template>

Container Sizing

The grid fills its parent container. Ensure the parent has explicit dimensions:

<template>
  <!-- Using inline styles -->
  <div style="width: 100%; height: 500px">
    <Grid :columns="columns" :row-data="data" :row-height="36" />
  </div>

  <!-- Using Tailwind CSS -->
  <div class="w-full h-[500px]">
    <Grid :columns="columns" :row-data="data" :row-height="36" />
  </div>
</template>

Reactive Data

Use ref or reactive for reactive data:

<script setup lang="ts">
import { ref } from "vue";
import { Grid, type ColumnDefinition } from "@gp-grid/vue";

const columns: ColumnDefinition[] = [
  { field: "id", cellDataType: "number", width: 80 },
  { field: "name", cellDataType: "text", width: 200 },
];

const data = ref([
  { id: 1, name: "Giovanni" },
  { id: 2, name: "Luca" },
]);

function addRow() {
  data.value.push({
    id: data.value.length + 1,
    name: "New Person",
  });
}
</script>

<template>
  <button @click="addRow">Add Row</button>
  <div style="height: 400px">
    <Grid :columns="columns" :row-data="data" :row-height="36" />
  </div>
</template>

Column Definitions

<script setup lang="ts">
const columns: ColumnDefinition[] = [
  {
    field: "id",
    cellDataType: "number",
    width: 80,
    headerName: "ID",
  },
  {
    field: "email",
    cellDataType: "text",
    width: 250,
    headerName: "Email Address",
    editable: true,
    sortable: true,
    filterable: true,
  },
];
</script>

Cell Data Types

TypeDescription
textString values
numberNumeric values
booleanTrue/false values
dateDate objects
dateStringDate as ISO string
dateTimeDateTime objects
dateTimeStringDateTime as ISO string
objectComplex objects

Dark Mode

Enable dark mode with the dark-mode prop:

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :dark-mode="true"
  />
</template>

With VueUse

<script setup lang="ts">
import { useDark } from "@vueuse/core";

const isDark = useDark();
</script>

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :dark-mode="isDark"
  />
</template>

Header Height & Overscan

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :header-height="48"
    :overscan="5"
  />
</template>

Next Steps

On this page

gp-grid-logo

Basic Usage

Walk through the fundamentals of using gp-grid in React, from defining columns and providing data to wiring up the Grid component in your first page today.

This guide covers the fundamentals of using gp-grid in your React application.

Don't forget to import the stylesheet once at the root of your app:

import "@gp-grid/react/dist/styles.css";

Minimal Example

The simplest grid requires three things: columns, data, and a row height.

import { Grid, type ColumnDefinition } from "@gp-grid/react";

const columns: ColumnDefinition[] = [
  { field: "id", cellDataType: "number", width: 80, headerName: "ID" },
  { field: "name", cellDataType: "text", width: 200, headerName: "Name" },
];

const data = [
  { id: 1, name: "Giovanni Rossi" },
  { id: 2, name: "Luca Verdi" },
];

function MyGrid() {
  return (
    <div style={{ width: "100%", height: "400px" }}>
      <Grid columns={columns} rowData={data} rowHeight={36} />
    </div>
  );
}

Container Sizing

The grid fills its parent container. Always ensure the parent has explicit dimensions:

// Using CSS
<div style={{ width: "100%", height: "500px" }}>
  <Grid columns={columns} rowData={data} rowHeight={36} />
</div>

// Using Tailwind CSS
<div className="w-full h-[500px]">
  <Grid columns={columns} rowData={data} rowHeight={36} />
</div>

Column Definitions

Each column requires at minimum a field, cellDataType, and width:

const columns: ColumnDefinition[] = [
  {
    field: "id",           // Property name in row data
    cellDataType: "number", // Data type for formatting
    width: 80,             // Column width in pixels
    headerName: "ID",      // Optional display name
  },
  {
    field: "email",
    cellDataType: "text",
    width: 250,
    headerName: "Email Address",
    editable: true,        // Enable editing
    sortable: true,        // Enable sorting (default: true)
    filterable: true,      // Enable filtering (default: true)
  },
];

Cell Data Types

TypeDescription
textString values
numberNumeric values
booleanTrue/false values
dateDate objects
dateStringDate as ISO string
dateTimeDateTime objects
dateTimeStringDateTime as ISO string
objectComplex objects

Dark Mode

Enable dark mode styling with the darkMode prop:

<Grid
  columns={columns}
  rowData={data}
  rowHeight={36}
  darkMode={true}
/>

For dynamic theme support with next-themes:

"use client";

import { useTheme } from "next-themes";
import { Grid } from "@gp-grid/react";

function ThemedGrid() {
  const { resolvedTheme } = useTheme();

  return (
    <Grid
      columns={columns}
      rowData={data}
      rowHeight={36}
      darkMode={resolvedTheme === "dark"}
    />
  );
}

Header Height

By default, the header height equals the row height. Override it with headerHeight:

<Grid
  columns={columns}
  rowData={data}
  rowHeight={36}
  headerHeight={48}  // Taller header
/>

Overscan

Control how many rows are rendered outside the visible viewport for smoother scrolling:

<Grid
  columns={columns}
  rowData={data}
  rowHeight={36}
  overscan={5}  // Render 5 extra rows above/below viewport
/>

Next Steps

On this page

gp-grid-logo

Basic Usage

Walk through the fundamentals of using gp-grid in Angular, from defining columns and providing data to wiring up the Grid component in your first page.

This page is being written. The React Basic Usage and Vue Basic Usage pages cover the same concepts — props, column definitions, and data types are identical across bindings.

Don't forget to import the stylesheet in your global styles.css:

@import "@gp-grid/angular/dist/styles.css";

Minimal Example

import { Component } from "@angular/core";
import { GridComponent, type ColumnDefinition } from "@gp-grid/angular";

@Component({
  selector: "app-my-grid",
  standalone: true,
  imports: [GridComponent],
  template: `
    <div style="width: 100%; height: 400px">
      <gp-grid
        [columns]="columns"
        [rowData]="data"
        [rowHeight]="36"
      />
    </div>
  `,
})
export class MyGridComponent {
  columns: ColumnDefinition[] = [
    { field: "id", cellDataType: "number", width: 80, headerName: "ID" },
    { field: "name", cellDataType: "text", width: 200, headerName: "Name" },
  ];

  data = [
    { id: 1, name: "Giovanni Rossi" },
    { id: 2, name: "Luca Verdi" },
  ];
}

Next Steps

On this page